var web = require('web');
var common = require('common');
var mud = require('./mud');

var router = web.createRouter();
var port = 8765;

var load = function(url, callback) {
	if (/^http:\/\//.test(url)) {
		require('http').cat(ref, callback);
		return;
	}
	if (/^file:\/\//.test(url)) {
		url = url.replace('file://localhost/', '/').replace('file://', '');		
		require('fs').readFile(url, 'utf8', callback);
		return;
	}
	callback(new Error('unknown protocol'));
};

router.get(/^\/dev(?:\?ref=(.*))?$/, function(request, response) {
	var ref = request.matches[1] ? decodeURIComponent(request.matches[1]) : request.headers.referer;
	var respond = function(src) {
		response.writeHead(200, {'content-type':'application/javascript'});
		response.end(src || '');
	};
	
	if (!ref) {
		respond(common.format('document.write(\'<script src="http://{0}/dev?ref=\'+window.location+\'"></script>\');', request.headers.host.split(':')[0]+':'+port));
		return;
	}
	
	load(ref, function(err, html) {
		mud.resolve({source:html, modulesOnly:true}, function(err, src) {
			response.writeHead(200);
			response.end(src);			
		});
	});
});

router.get(web.onfilerequest('.'));

router.listen(8765);