var web = require('web');
var mud = require('mud'); // should be integrated

var router = web.createRouter();

router.get(/^\/s\//, web.onfilerequest(__dirname)); // static files from the /s/ dir

router.get('/dev', function(request, response) { // shortcut - TODO: check if referrer is changed
	response.writeHead(301, {location:'http://localhost:10000/dev'});
	response.end();
});
router.get(/^\/g\/(.+)/, function(request, response) { // global modules
	var modules = request.matches[1].split(',');
	
	mud.resolve({modules:modules, global:modules}, function(err, src) {
		response.writeHead(200, {'content-type':'application/javascript'});
		response.end(src || '');
	});
});
router.get(/^\/m\/(.+)/, function(request, response) { // regular modules
	mud.resolve({modules:request.matches[1].split(',')}, function(err, src) {
		response.writeHead(200, {'content-type':'application/javascript'});
		response.end(src || '');
	});
});

router.get('/list', '/s/list.html', router.route);
router.get('/', '/s/index.html', router.route);

router.listen(8000);